diff -wrubN quake3_1.32b/code/qcommon/msg.c dfengine_1.07_src/code/qcommon/msg.c
--- quake3_1.32b/code/qcommon/msg.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/qcommon/msg.c	2009-05-18 13:44:57.000000000 +0200
@@ -22,10 +22,6 @@
 #include "../game/q_shared.h"
 #include "qcommon.h"
 
-static huffman_t		msgHuff;
-
-static qboolean			msgInit = qfalse;
-
 int pcount[256];
 
 /*
@@ -39,21 +35,13 @@
 
 int oldsize = 0;
 
-void MSG_initHuffman();
-
 void MSG_Init( msg_t *buf, byte *data, int length ) {
-	if (!msgInit) {
-		MSG_initHuffman();
-	}
 	Com_Memset (buf, 0, sizeof(*buf));
 	buf->data = data;
 	buf->maxsize = length;
 }
 
 void MSG_InitOOB( msg_t *buf, byte *data, int length ) {
-	if (!msgInit) {
-		MSG_initHuffman();
-	}
 	Com_Memset (buf, 0, sizeof(*buf));
 	buf->data = data;
 	buf->maxsize = length;
@@ -172,7 +160,7 @@
 		if (bits) {
 			for(i=0;i<bits;i+=8) {
 //				fwrite(bp, 1, 1, fp);
-				Huff_offsetTransmit (&msgHuff.compressor, (value&0xff), msg->data, &msg->bit);
+				Huff_offsetTransmit ((value&0xff), msg->data, &msg->bit);
 				value = (value>>8);
 			}
 		}
@@ -227,7 +215,7 @@
 		if (bits) {
 //			fp = fopen("c:\\netchan.bin", "a");
 			for(i=0;i<bits;i+=8) {
-				Huff_offsetReceive (msgHuff.decompressor.tree, &get, msg->data, &msg->bit);
+				Huff_offsetReceive (&get, msg->data, &msg->bit);
 //				fwrite(&get, 1, 1, fp);
 				value |= (get<<(i+nbits));
 			}
@@ -1447,311 +1435,4 @@
 	}
 }
 
-int msg_hData[256] = {
-250315,			// 0
-41193,			// 1
-6292,			// 2
-7106,			// 3
-3730,			// 4
-3750,			// 5
-6110,			// 6
-23283,			// 7
-33317,			// 8
-6950,			// 9
-7838,			// 10
-9714,			// 11
-9257,			// 12
-17259,			// 13
-3949,			// 14
-1778,			// 15
-8288,			// 16
-1604,			// 17
-1590,			// 18
-1663,			// 19
-1100,			// 20
-1213,			// 21
-1238,			// 22
-1134,			// 23
-1749,			// 24
-1059,			// 25
-1246,			// 26
-1149,			// 27
-1273,			// 28
-4486,			// 29
-2805,			// 30
-3472,			// 31
-21819,			// 32
-1159,			// 33
-1670,			// 34
-1066,			// 35
-1043,			// 36
-1012,			// 37
-1053,			// 38
-1070,			// 39
-1726,			// 40
-888,			// 41
-1180,			// 42
-850,			// 43
-960,			// 44
-780,			// 45
-1752,			// 46
-3296,			// 47
-10630,			// 48
-4514,			// 49
-5881,			// 50
-2685,			// 51
-4650,			// 52
-3837,			// 53
-2093,			// 54
-1867,			// 55
-2584,			// 56
-1949,			// 57
-1972,			// 58
-940,			// 59
-1134,			// 60
-1788,			// 61
-1670,			// 62
-1206,			// 63
-5719,			// 64
-6128,			// 65
-7222,			// 66
-6654,			// 67
-3710,			// 68
-3795,			// 69
-1492,			// 70
-1524,			// 71
-2215,			// 72
-1140,			// 73
-1355,			// 74
-971,			// 75
-2180,			// 76
-1248,			// 77
-1328,			// 78
-1195,			// 79
-1770,			// 80
-1078,			// 81
-1264,			// 82
-1266,			// 83
-1168,			// 84
-965,			// 85
-1155,			// 86
-1186,			// 87
-1347,			// 88
-1228,			// 89
-1529,			// 90
-1600,			// 91
-2617,			// 92
-2048,			// 93
-2546,			// 94
-3275,			// 95
-2410,			// 96
-3585,			// 97
-2504,			// 98
-2800,			// 99
-2675,			// 100
-6146,			// 101
-3663,			// 102
-2840,			// 103
-14253,			// 104
-3164,			// 105
-2221,			// 106
-1687,			// 107
-3208,			// 108
-2739,			// 109
-3512,			// 110
-4796,			// 111
-4091,			// 112
-3515,			// 113
-5288,			// 114
-4016,			// 115
-7937,			// 116
-6031,			// 117
-5360,			// 118
-3924,			// 119
-4892,			// 120
-3743,			// 121
-4566,			// 122
-4807,			// 123
-5852,			// 124
-6400,			// 125
-6225,			// 126
-8291,			// 127
-23243,			// 128
-7838,			// 129
-7073,			// 130
-8935,			// 131
-5437,			// 132
-4483,			// 133
-3641,			// 134
-5256,			// 135
-5312,			// 136
-5328,			// 137
-5370,			// 138
-3492,			// 139
-2458,			// 140
-1694,			// 141
-1821,			// 142
-2121,			// 143
-1916,			// 144
-1149,			// 145
-1516,			// 146
-1367,			// 147
-1236,			// 148
-1029,			// 149
-1258,			// 150
-1104,			// 151
-1245,			// 152
-1006,			// 153
-1149,			// 154
-1025,			// 155
-1241,			// 156
-952,			// 157
-1287,			// 158
-997,			// 159
-1713,			// 160
-1009,			// 161
-1187,			// 162
-879,			// 163
-1099,			// 164
-929,			// 165
-1078,			// 166
-951,			// 167
-1656,			// 168
-930,			// 169
-1153,			// 170
-1030,			// 171
-1262,			// 172
-1062,			// 173
-1214,			// 174
-1060,			// 175
-1621,			// 176
-930,			// 177
-1106,			// 178
-912,			// 179
-1034,			// 180
-892,			// 181
-1158,			// 182
-990,			// 183
-1175,			// 184
-850,			// 185
-1121,			// 186
-903,			// 187
-1087,			// 188
-920,			// 189
-1144,			// 190
-1056,			// 191
-3462,			// 192
-2240,			// 193
-4397,			// 194
-12136,			// 195
-7758,			// 196
-1345,			// 197
-1307,			// 198
-3278,			// 199
-1950,			// 200
-886,			// 201
-1023,			// 202
-1112,			// 203
-1077,			// 204
-1042,			// 205
-1061,			// 206
-1071,			// 207
-1484,			// 208
-1001,			// 209
-1096,			// 210
-915,			// 211
-1052,			// 212
-995,			// 213
-1070,			// 214
-876,			// 215
-1111,			// 216
-851,			// 217
-1059,			// 218
-805,			// 219
-1112,			// 220
-923,			// 221
-1103,			// 222
-817,			// 223
-1899,			// 224
-1872,			// 225
-976,			// 226
-841,			// 227
-1127,			// 228
-956,			// 229
-1159,			// 230
-950,			// 231
-7791,			// 232
-954,			// 233
-1289,			// 234
-933,			// 235
-1127,			// 236
-3207,			// 237
-1020,			// 238
-927,			// 239
-1355,			// 240
-768,			// 241
-1040,			// 242
-745,			// 243
-952,			// 244
-805,			// 245
-1073,			// 246
-740,			// 247
-1013,			// 248
-805,			// 249
-1008,			// 250
-796,			// 251
-996,			// 252
-1057,			// 253
-11457,			// 254
-13504,			// 255
-};
-
-void MSG_initHuffman() {
-	int i,j;
-
-	msgInit = qtrue;
-	Huff_Init(&msgHuff);
-	for(i=0;i<256;i++) {
-		for (j=0;j<msg_hData[i];j++) {
-			Huff_addRef(&msgHuff.compressor,	(byte)i);			// Do update
-			Huff_addRef(&msgHuff.decompressor,	(byte)i);			// Do update
-		}
-	}
-}
-
-/*
-void MSG_NUinitHuffman() {
-	byte	*data;
-	int		size, i, ch;
-	int		array[256];
-
-	msgInit = qtrue;
-
-	Huff_Init(&msgHuff);
-	// load it in
-	size = FS_ReadFile( "netchan/netchan.bin", (void **)&data );
-
-	for(i=0;i<256;i++) {
-		array[i] = 0;
-	}
-	for(i=0;i<size;i++) {
-		ch = data[i];
-		Huff_addRef(&msgHuff.compressor,	ch);			// Do update
-		Huff_addRef(&msgHuff.decompressor,	ch);			// Do update
-		array[ch]++;
-	}
-	Com_Printf("msg_hData {\n");
-	for(i=0;i<256;i++) {
-		if (array[i] == 0) {
-			Huff_addRef(&msgHuff.compressor,	i);			// Do update
-			Huff_addRef(&msgHuff.decompressor,	i);			// Do update
-		}
-		Com_Printf("%d,			// %d\n", array[i], i);
-	}
-	Com_Printf("};\n");
-	FS_FreeFile( data );
-	Cbuf_AddText( "condump dump.txt\n" );
-}
-*/
-
 //===========================================================================
diff -wrubN quake3_1.32b/code/qcommon/qcommon.h dfengine_1.07_src/code/qcommon/qcommon.h
--- quake3_1.32b/code/qcommon/qcommon.h	2009-04-18 19:32:30.000000000 +0200
+++ dfengine_1.07_src/code/qcommon/qcommon.h	2009-05-18 13:44:57.000000000 +0200
@@ -543,6 +543,7 @@
 // will properly create any needed paths and deal with seperater character issues
 
 int		FS_filelength( fileHandle_t f );
+qboolean FS_SV_FileExists( const char *file );	// Cgg - was missing
 fileHandle_t FS_SV_FOpenFileWrite( const char *filename );
 int		FS_SV_FOpenFileRead( const char *filename, fileHandle_t *fp );
 void	FS_SV_Rename( const char *from, const char *to );
@@ -627,12 +628,19 @@
 // separated checksums will be checked for files, with the
 // sole exception of .cfg files.
 
-qboolean FS_idPak( char *pak, char *base );
+qboolean FS_idPak( const char *pak, const char *base );
 qboolean FS_ComparePaks( char *neededpaks, int len, qboolean dlstring );
 
 void FS_Rename( const char *from, const char *to );
 
-// Cgg - autocompletion on map & demo names
+// Cgg
+// return the current gamedir (eg. "baseq3", "mymod"...)
+const char *FS_GetGameDir();
+// remove a file from the homepath (eg. C:\quake3\; ~/.q3a/)
+qboolean FS_SV_RemoveFile(const char *filepath);
+// remove a file from homepath/gamedir (eg. C:\quake3\mymod\; ~/.q3a/mymod)
+qboolean FS_RemoveFile(const char *filename);
+// autocompletion on map & demo names
 void Maps_CommandCompletion(void (*callback) (const char *s));
 void Demos_CommandCompletion(void (*callback) (const char *s));
 // !Cgg
@@ -1042,28 +1050,21 @@
 	node_t*		loc[HMAX+1];
 	node_t**	freelist;
 
-	node_t		nodeList[768];
-	node_t*		nodePtrs[768];
+	// Cgg - had 768 nodes; while actual max is (256 values + NYT) *2 -1 => 513
+	node_t		nodeList[513];
+	node_t*		nodePtrs[513];
 } huff_t;
 
-typedef struct {
-	huff_t		compressor;
-	huff_t		decompressor;
-} huffman_t;
-
 void	Huff_Compress(msg_t *buf, int offset);
 void	Huff_Decompress(msg_t *buf, int offset);
-void	Huff_Init(huffman_t *huff);
 void	Huff_addRef(huff_t* huff, byte ch);
 int		Huff_Receive (node_t *node, int *ch, byte *fin);
 void	Huff_transmit (huff_t *huff, int ch, byte *fout);
-void	Huff_offsetReceive (node_t *node, int *ch, byte *fin, int *offset);
-void	Huff_offsetTransmit (huff_t *huff, int ch, byte *fout, int *offset);
+void	Huff_offsetReceive (int *ch, byte *fin, int *offset);	// Cgg (changed prototype)
+void	Huff_offsetTransmit (int ch, byte *fout, int *offset);	// Cgg (changed prototype)
 void	Huff_putBit( int bit, byte *fout, int *offset);
 int		Huff_getBit( byte *fout, int *offset);
 
-extern huffman_t clientHuffTables;
-
 #define	SV_ENCODE_START		4
 #define SV_DECODE_START		12
 #define	CL_ENCODE_START		12
diff -wrubN quake3_1.32b/code/renderer/qgl.h dfengine_1.07_src/code/renderer/qgl.h
--- quake3_1.32b/code/renderer/qgl.h	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/renderer/qgl.h	2009-04-18 19:37:40.000000000 +0200
@@ -90,6 +90,12 @@
 #define GL_TEXTURE2_ARB                     0x84C2
 #define GL_TEXTURE3_ARB                     0x84C3
 
+// marky
+#ifndef GL_EXT_texture_edge_clamp
+#define GL_EXT_CLAMP_TO_EDGE                 0x812F
+#endif
+// !marky
+
 // NOTE: some Linux platforms would need those prototypes
 #if defined(MACOS_X)
 typedef void (APIENTRY * PFNGLMULTITEXCOORD1DARBPROC) (GLenum target, GLdouble s);
diff -wrubN quake3_1.32b/code/renderer/tr_init.c dfengine_1.07_src/code/renderer/tr_init.c
--- quake3_1.32b/code/renderer/tr_init.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/renderer/tr_init.c	2009-05-26 12:06:05.000000000 +0200
@@ -226,8 +226,10 @@
 	// init command buffers and SMP
 	R_InitCommandBuffers();
 
+	// Cgg - spammy
 	// print info
-	GfxInfo_f();
+	//GfxInfo_f();
+	// !Cgg
 
 	// set default state
 	GL_SetDefaultState();
@@ -384,6 +386,7 @@
 	buffer[15] = height >> 8;
 	buffer[16] = 24;	// pixel size
 
+	qglPixelStorei(GL_PACK_ALIGNMENT, 1); //marky: fixes nonstandard res'
 	qglReadPixels( x, y, width, height, GL_RGB, GL_UNSIGNED_BYTE, buffer+18 ); 
 
 	// swap rgb to bgr
@@ -847,6 +850,43 @@
 	}
 }
 
+
+// drakkar
+/*
+================
+R_WindowMode_f
+================
+*/
+void R_WindowMode_f( void ) 
+{
+	char *str = NULL;
+
+	str = ri.Cmd_Argv(1);
+	
+	if     ( !strncasecmp( str, "restart",        7 ) )  GLimp_WindowMode( WMODE_RESTART );
+	else if( !strncasecmp( str, "minimized",      3 ) )  GLimp_WindowMode( WMODE_SET_MINIMIZED );
+	else if( !strncasecmp( str, "windowed",       3 ) )  GLimp_WindowMode( WMODE_SET_WINDOWED );
+	else if( !strncasecmp( str, "fullscreen",     4 ) )  GLimp_WindowMode( WMODE_SET_FULLSCREEN );
+	else if( !strncasecmp( str, "swapFullscreen", 8 ) )  GLimp_WindowMode( WMODE_SWAP_FULLSCREEN );
+	else if( !strncasecmp( str, "swapMinimized",  7 ) )  GLimp_WindowMode( WMODE_SWAP_MINIMIZED );
+	else
+	{
+		str = ri.Cmd_Argv(0);
+		ri.Printf( PRINT_ALL,
+			"How to use:\n"
+			"\\%s restart\n"
+			"\\%s minimized\n"
+			"\\%s windowed\n"
+			"\\%s fullscreen\n"
+			"\\%s swapFullscreen\n"
+			"\\%s swapMinimized\n"
+			, str, str, str, str, str, str
+		);
+	}
+}
+// !drakkar
+
+
 /*
 ===============
 R_Register
@@ -1003,6 +1043,9 @@
 	ri.Cmd_AddCommand( "screenshot", R_ScreenShot_f );
 	ri.Cmd_AddCommand( "screenshotJPEG", R_ScreenShotJPEG_f );
 	ri.Cmd_AddCommand( "gfxinfo", GfxInfo_f );
+	// drakkar
+	ri.Cmd_AddCommand( "windowMode", R_WindowMode_f );
+	// !drakkar
 }
 
 /*
@@ -1122,6 +1165,9 @@
 	ri.Cmd_RemoveCommand ("gfxinfo");
 	ri.Cmd_RemoveCommand( "modelist" );
 	ri.Cmd_RemoveCommand( "shaderstate" );
+	// drakkar
+	ri.Cmd_RemoveCommand( "windowMode" );
+	// !drakkar
 
 
 	if ( tr.registered ) {
diff -wrubN quake3_1.32b/code/renderer/tr_local.h dfengine_1.07_src/code/renderer/tr_local.h
--- quake3_1.32b/code/renderer/tr_local.h	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/renderer/tr_local.h	2009-05-21 14:53:03.000000000 +0200
@@ -1247,6 +1247,18 @@
 						    unsigned char green[256],
 							unsigned char blue[256] );
 
+// drakkar
+typedef enum {
+	WMODE_RESTART = 0,
+	WMODE_SET_MINIMIZED,
+	WMODE_SET_WINDOWED,
+	WMODE_SET_FULLSCREEN,
+	WMODE_SWAP_FULLSCREEN,
+	WMODE_SWAP_MINIMIZED
+} windowMode_t;
+void GLimp_WindowMode( windowMode_t wmode );
+// !drakkar
+
 
 /*
 ====================================================================
diff -wrubN quake3_1.32b/code/renderer/tr_shader.c dfengine_1.07_src/code/renderer/tr_shader.c
--- quake3_1.32b/code/renderer/tr_shader.c	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/renderer/tr_shader.c	2009-05-26 12:06:05.000000000 +0200
@@ -1227,7 +1227,7 @@
 		for (i=0 ; i<6 ; i++) {
 			Com_sprintf( pathname, sizeof(pathname), "%s_%s.tga"
 				, token, suf[i] );
-			shader.sky.outerbox[i] = R_FindImageFile( ( char * ) pathname, qtrue, qtrue, GL_CLAMP );
+			shader.sky.outerbox[i] = R_FindImageFile( ( char * ) pathname, qtrue, qtrue, GL_EXT_CLAMP_TO_EDGE );	// marky: GL_CLAMP to GL_CLAMP_TO_EDGE
 			if ( !shader.sky.outerbox[i] ) {
 				shader.sky.outerbox[i] = tr.defaultImage;
 			}
@@ -2872,7 +2872,9 @@
 		char filename[MAX_QPATH];
 
 		Com_sprintf( filename, sizeof( filename ), "scripts/%s", shaderFiles[i] );
-		ri.Printf( PRINT_ALL, "...loading '%s'\n", filename );
+// Cgg - spammy and rather pointless - made it PRINT_DEV
+		ri.Printf( PRINT_DEVELOPER, "...loading '%s'\n", filename );
+// !Cgg
 		sum += ri.FS_ReadFile( filename, (void **)&buffers[i] );
 		if ( !buffers[i] ) {
 			ri.Error( ERR_DROP, "Couldn't load %s", filename );
diff -wrubN quake3_1.32b/code/ui/keycodes.h dfengine_1.07_src/code/ui/keycodes.h
--- quake3_1.32b/code/ui/keycodes.h	2009-04-18 19:29:36.000000000 +0200
+++ dfengine_1.07_src/code/ui/keycodes.h	2009-05-25 11:51:16.000000000 +0200
@@ -151,6 +151,11 @@
 	K_AUX15,
 	K_AUX16,
 
+// drakkar
+	K_WIN,
+	K_MENU,
+// !drakkar
+
 	K_LAST_KEY		// this had better be <256!
 } keyNum_t;
 
